﻿@using ProyectoFase2.Shared.General;
@using ProyectoFase2.Shared.Models.Paper;
@inject INotificationCustomerService NotificationService
@inject IHTTPClientRequestService Http
@inject IJSRuntime JSRuntime
@inject IToolTipCustomer tooltipService
@inject DialogService DialogService

@if (LoadingData)
{
    <RadzenCardLoader IsLoading="@LoadingData">
    </RadzenCardLoader>
}
else
{
    <RadzenCard Class="rz-mx-auto">
        <RadzenDataGrid AllowFiltering="true"
                        AllowVirtualization="true"
                        AllowColumnResize="true"
                        AllowAlternatingRows="false"
                        FilterMode="FilterMode.Advanced"
                        AllowSorting="true"
                        PageSize="25"
                        AllowPaging="true"
                        PagerHorizontalAlign="HorizontalAlign.Left"
                        ShowPagingSummary="true"
        @ref="grid"
                        Data="@Items"
                        TItem="PaperDTO"
                        LogicalFilterOperator="LogicalFilterOperator.Or">
            <Columns>
                <RadzenDataGridColumn TItem="PaperDTO" Property="Name" Title="Nombre">
                    <Template Context="data">
                        <p style="white-space:pre-wrap">@data.Name</p>
                    </Template>
                </RadzenDataGridColumn>
                <RadzenDataGridColumn TItem="PaperDTO" Property="Description" Title="Descripción">
                    <Template Context="data">
                        <div style="max-height: 6em; overflow-y: auto;">
                            <p style="white-space: pre-wrap; margin: 0;">@data.Description</p>
                        </div>
                    </Template>
                </RadzenDataGridColumn>
                <RadzenDataGridColumn TItem="PaperDTO" Property="Abstract" Title="Abstract">
                    <Template Context="data">
                        <div style="max-height: 6em; overflow-y: auto;">
                            <p style="white-space: pre-wrap; margin: 0;">@data.Abstract</p>
                        </div>
                    </Template>
                </RadzenDataGridColumn>


                <RadzenDataGridColumn Width="160px"
                                      TItem="PaperDTO"
                                      Property="Uri"
                                      Title="Opciones">
                    <Template Context="data">
                        <RadzenButton ButtonStyle="ButtonStyle.Info"
                                      MouseEnter="@(args => ShowTooltip(args,"Ver PDF") )"
                                      Variant="Variant.Flat"
                                      Shade="Shade.Darker"
                                      Icon="picture_as_pdf"
                                      class="m-1"
                                      Click=@(async () => await OpenPDF(data)) />
                        <RadzenButton ButtonStyle="ButtonStyle.Secondary"
                                      MouseEnter="@(args => ShowTooltip(args,"Editar") )"
                                      Variant="Variant.Flat"
                                      Shade="Shade.Darker"
                                      Icon="edit"
                                      class="m-1"
                                      Click=@(async () => await EditPaper(data)) />
                        <RadzenButton ButtonStyle="ButtonStyle.Danger"
                                      MouseEnter="@(args => ShowTooltip(args,"Eliminar") )"
                                      Variant="Variant.Flat"
                                      Shade="Shade.Darker"
                                      Icon="delete"
                                      class="m-1"
                                      Click=@(async () => await DeletePaper(data)) />
                    </Template>
                </RadzenDataGridColumn>
            </Columns>
        </RadzenDataGrid>
    </RadzenCard>
}

@code
{
    RadzenDataGrid<PaperDTO> grid;

    TabPosition tabPosition = TabPosition.Top;
    public bool LoadingData { get; set; } = false;

    public IEnumerable<PaperDTO> Items { get; set; }



    protected override async Task OnInitializedAsync()
    {
        try
        {
            LoadingData = true;
            await this.LoadData();
            LoadingData = false;
        }
        catch (Exception ex)
        {
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    public async Task LoadData()
    {
        try
        {
            LoadingData = true;

            var request = await Http.Get<ListItemDTO<PaperDTO>>("api/Paper");

            if (request.Succeeded)
            {
                if (request.Result != null && request.Result.Value != null)
                {
                    Items = request.Result.Value;
                }
                else
                {
                    NotificationService.Notify("No se encontraron datos.", NotificationSeverity.Warning);
                }
            }
            else
            {
                NotificationService.Notify("Ocurrió un error cargando la información.", NotificationSeverity.Error);
            }
        }
        catch (Exception ex)
        {
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    public async Task OpenPDF(PaperDTO paperDTO)
    {
        try
        {
            LoadingData = true;
            NotificationService.Notify("Abriendo PDF...", NotificationSeverity.Info);
            string url = $"/paper/pdfviewer/{paperDTO.Id}";
            await JSRuntime.InvokeVoidAsync("window.open", url, "_blank");
        }
        catch (Exception ex)
        {
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    public async Task DeletePaper(PaperDTO paperDTO)
    {
        try
        {
            var result = await DialogService.OpenAsync("Eliminar", ds =>
    @<div>
        <p Style="margin-bottom: 1rem">¿Esta seguro que desea eliminar el registro? </p>
        <div class="row">
            <div class="col-md-12">
                <RadzenButton Text="Ok" Click="() => ds.Close(true)" Style="margin-bottom: 10px; width: 150px" />
                <RadzenButton Text="Cancel" Click="() => ds.Close(false)" ButtonStyle="ButtonStyle.Secondary" Style="margin-bottom: 10px; width: 150px" />
            </div>
        </div>
    </div>
    );

            if (result == false)
            {
                return;
            }

            LoadingData = true;


            var request = await Http.Delete<bool>($"api/Paper/{paperDTO.Id}");

            if (request.Succeeded)
            {
                NotificationService.Notify("Se eliminó el registro correctamente.", NotificationSeverity.Success);
                await this.LoadData();
            }
            else
            {
                var error = request.ErrorMessage();
                NotificationService.Notify(error, NotificationSeverity.Error);
            }
        }
        catch (Exception e)
        {
            NotificationService.Notify(e.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    public async Task EditPaper(PaperDTO paperDTO)
    {
        try
        {
            LoadingData = true;
            string url = $"/paper/Edit/{paperDTO.Id}";
            await JSRuntime.InvokeVoidAsync("eval", $"window.location.href = '{url}';");
        }
        catch (Exception e)
        {
            NotificationService.Notify(e.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    void ShowTooltip(ElementReference elementReference, string text)
    {
        tooltipService.ShowToolTip(elementReference, text);
    }
}
